<template>
  <div :class="{'has-logo': showLogo}">
    <sidebar-logo
      v-if="showLogo"
      :collapse="isCollapse"
    />
    <el-scrollbar wrap-class="scrollbar-wrapper">
      <el-menu
        :active-text-color="menuActiveTextColor"
        :background-color="variables.menuBg"
        :collapse="isCollapse"
        :collapse-transition="false"
        :default-active="activeMenu"
        :text-color="variables.menuText"
        :unique-opened="false"
        mode="vertical"
      >
        <sidebar-item
          v-for="route in routes"
          :key="route.path"
          :base-path="route.path"
          :is-collapse="isCollapse"
          :item="route"
        />
      </el-menu>
    </el-scrollbar>
  </div>
</template>

<script lang="ts">
import { Component, Vue } from 'vue-property-decorator'
import { AppModule } from '@/store/modules/app'
import { SettingsModule } from '@/store/modules/settings'
import SidebarItem from './SidebarItem.vue'
import SidebarLogo from './SidebarLogo.vue'
import variables from '@/styles/_variables.scss'
import i18n from '@/lang' // Internationalizatio
import { RouteConfig } from 'vue-router'

@Component({
  name: 'SideBar',
  components: {
    SidebarItem,
    SidebarLogo
  }
})
export default class extends Vue {
  private menuListPData = {} as _menu._pindexMenuList
  private menuListRData = {} as _menu._rindexMenuList
  private routersData = [] as RouteConfig[]

  get sidebar() {
    return AppModule.sidebar
  }

  get routes() {
    return this.routersData
  }

  get showLogo() {
    return SettingsModule.showSidebarLogo
  }

  get menuActiveTextColor() {
    if (SettingsModule.sidebarTextTheme) {
      return SettingsModule.theme
    } else {
      return variables.menuActiveText
    }
  }

  get variables() {
    return variables
  }

  get activeMenu() {
    const route = this.$route
    const { meta, path } = route
    // if set path, the sidebar will highlight the path you set
    if (meta.activeMenu) {
      return meta.activeMenu
    }
    return path
  }

  get isCollapse() {
    return !this.sidebar.opened
  }

  getPageTitle(key?: string) {
    const hasKey = i18n.te(`route.${key}`)
    return hasKey
  }

  returnAuth(arr: any) {
    const rArr = [] as any[]
    arr.map((item: any) => {
      if (item.menuState === '1') rArr.push(...[item.menuName, item.menuUrl])
    })
    return rArr
  }

  returnRouter(obj: _menu.Menu, parent?: boolean): RouteConfig {
    const data = {} as RouteConfig
    data.path = obj.menuUrl === '#' ? obj.menuId.toString() : obj.menuUrl
    data.redirect = obj.menuId.toString()
    data.name = obj.menuUrl.replace('/', '')
    data.meta = {
      title: obj.menuName,
      icon: parent || obj.menuName === '首页' ? obj.menuIcon : ''
    }
    if (parent && obj.menuName !== '首页') data.meta.alwaysShow = true
    return data
  }

  async getMenu() {
    this.menuListRData = await this.$API._menuindexMenuList({
      data: this.menuListPData
    })
    if (this.menuListRData.code !== '0000') return false
    const routerAuth = [] as RouteConfig[]
    this.menuListRData.data.map((item: _menu.Menu) => {
      let temp = {} as RouteConfig
      if (item.menuState === '1') { temp = this.returnRouter(item, true) }
      if (item.menuState === '1' && item.subMenu && item.subMenu.length > 0) {
        item.subMenu.map(subItem => {
          if (subItem.menuState === '1' && temp.children) temp.children.push(this.returnRouter(subItem))
          if (subItem.menuState === '1' && !temp.children) temp.children = [this.returnRouter(subItem)]
        })
      }
      if (temp.path) routerAuth.push(temp)
    })
    this.routersData = routerAuth
  }

  mounted() {
    this.getMenu()
  }
}
</script>

<style lang="scss">
.sidebar-container {
  // reset element-ui css
  .horizontal-collapse-transition {
    transition: 0s width ease-in-out, 0s padding-left ease-in-out,
      0s padding-right ease-in-out;
  }

  .scrollbar-wrapper {
    overflow-x: hidden !important;
  }

  .el-scrollbar__view {
    height: 100%;
  }

  .el-scrollbar__bar {
    &.is-vertical {
      right: 0px;
    }

    &.is-horizontal {
      display: none;
    }
  }
}
</style>

<style lang="scss" scoped>
.el-scrollbar {
  height: 100%;
}

.has-logo {
  .el-scrollbar {
    height: calc(100% - 50px);
  }
}

.el-menu {
  border: none;
  height: 100%;
  width: 100% !important;
}
</style>
